/************************************************************************************************************************************
    Name        :   ProcessAffiliationRulesBatch.cls
    Description :   Batch Class to process account affiliation rules on Account assignments post account movement and account sharing
    Author      :   Raghvendra Rathore
    Created On  :   04/23/2018
*************************************************************************************************************************************/
global class ProcessAffiliationRulesBatch implements Database.Batchable<sObject>, Database.Stateful{ 
    
    global String query;
    global Id teamInstanceId;
    global Team_Instance__c teamInstance;
    global AffiliationRule affRule;
    global set<Id> accountsToBeProcessed;
    global set<Id> posAccIds;
    global list<String> newlyAlignedAccounts = new list<String>();
    global set<Id> excludedAccountIds = new set<Id>();
    global integer affiliationHierarchyThreshold;
    
    /*
    	Constructor 1	: Invoked after account movement
    	Param1			: teamInstance Id
    	Param2			: set of moved account ids
	*/
    global ProcessAffiliationRulesBatch(Id teamInstanceId, set<Id> accountsToBeProcessed){
    	system.debug('#### ProcessAffiliationRulesBatch for Account movement');
    	this.teamInstanceId = teamInstanceId;
    	this.accountsToBeProcessed = accountsToBeProcessed;
    	init();
    }

    /*
    	Constructor 2	: Invoked after account sharing
    	Param1			: teamInstance Id
    	Param2			: Change Request Id
    	Param3			: set of moved account ids
	*/
    global ProcessAffiliationRulesBatch(Id teamInstanceId, Id crId, set<Id> accountsToBeProcessed){
    	system.debug('#### ProcessAffiliationRulesBatch for Account movement');
    	Change_Request__c crObj = [SELECT Id, (SELECT Account__c FROM CR_Accounts__r WHERE Account_Alignment_Type__c = 'Explicit') FROM Change_Request__c WHERE Id =: crId];
		//Find excluded accounts while ZIP movemet in hybrid team instance. Only work with CR tracking on.
		for(CR_Account__c crAcc : crObj.CR_Accounts__r){
			excludedAccountIds.add(crAcc.Account__c);
		}

    	this.teamInstanceId = teamInstanceId;
    	this.accountsToBeProcessed = accountsToBeProcessed;
    	init();
    }

    global void init(){
    	try{
    		system.debug('#### init called');

    		Alignment_Global_Settings__c AffHierarchyThresholdConfig = Alignment_Global_Settings__c.getValues('AffiliationHierarchyThreshold');
			this.affiliationHierarchyThreshold = 5;
			if(AffHierarchyThresholdConfig != null){
				try{
					this.affiliationHierarchyThreshold = Integer.valueOf(AffHierarchyThresholdConfig.Tree_Hierarchy_Sort_Field__c);
				}catch(TypeException e){
					this.affiliationHierarchyThreshold = 5;
				}
			}

	    	teamInstance = [SELECT Id, Scenario__c, Alignment_Period__c, Alignment_Type__c, Affiliation_Network__c, Scenario__r.Enable_Affiliation_Based_Alignment__c, EnableAccountSharing__c, IC_EffstartDate__c, IC_EffEndDate__c FROM Team_Instance__c WHERE Id =: teamInstanceId];
	    	/**
	    	* Modified : Raghvendra | 27 Sep 2018 | SIQ-2715
	    	* Allow Account affiliation for ZIP based team
	    	**/
	    	if(teamInstance.Scenario__r.Enable_Affiliation_Based_Alignment__c && teamInstance.EnableAccountSharing__c && teamInstance.Affiliation_Network__c != null){
	    		affRule = getAffiliationBusinessRule(teamInstance.Scenario__c);
	    		if(affRule == null){
	    			throw new InsufficentPriviligesException('Affiliation rule not found');
	    		}
	    		query = 'Select logged__c, isExcluded__c, TempDestinationrgb__c, Team_Instance__c, SharedWith__c, Segment_1__c, Position__c, Position_Team_Instance__c, Name, Metric9__c, Metric8__c, Metric7__c, Metric6__c, Metric5__c, Metric4__c, Metric3__c, Metric2__c, Metric1__c, Metric10__c, Locked__c, Effective_Start_Date__c, Effective_End_Date__c, Comments__c, Affiliation_Based_Alignment__c, Account__c, Account_Target_Type__c, Account_Relationship_Type__c, Account_Alignment_Type__c From Position_Account__c ';
	    		query += 'WHERE Account__c IN : accountsToBeProcessed AND Team_Instance__c =: teamInstanceId AND Assignment_Status__c != \''+SalesIQGlobalConstants.POSITION_ACCOUNT_INACTIVE+'\'';
	    	}else{
	    		query = 'SELECT Id, Team_Instance__c, Position__c, Account__c FROM Position_Account__c WHERE Name = null';
	    	}
    	}catch(Exception e){
    		system.debug('#### ERROR : '+e.getMessage());
    		query = 'SELECT Id, Team_Instance__c, Position__c, Account__c FROM Position_Account__c WHERE Name = null';
    		SalesIQLogger.logCatchedException(e,'Affiliation Rule Post Processing');
    	}
    	system.debug('#### query : '+query);
    	system.debug('#### teamInstanceId : '+teamInstanceId);
    	system.debug('#### excludedAccountIds : '+excludedAccountIds);
    }

    /*
    	Constructor 3	: Invoked after account sharing
    	Param1			: teamInstance Id
    	Param2			: list of shared position account.
    	Param3			: operation - Add/Remove (To be used later)
	*/
    global ProcessAffiliationRulesBatch(Id teamInstanceId, list<Position_Account__c> posAccToBeProcessed, string operation){
    	system.debug('#### ProcessAffiliationRulesBatch for sharing');
    	try{
			Alignment_Global_Settings__c AffHierarchyThresholdConfig = Alignment_Global_Settings__c.getValues('AffiliationHierarchyThreshold');
			this.affiliationHierarchyThreshold = 5;
			if(AffHierarchyThresholdConfig != null){
				try{
					this.affiliationHierarchyThreshold = Integer.valueOf(AffHierarchyThresholdConfig.Tree_Hierarchy_Sort_Field__c);
				}catch(TypeException e){
					this.affiliationHierarchyThreshold = 5;
				}
			}
    		
	    	this.teamInstanceId = teamInstanceId;
	    	this.accountsToBeProcessed = new set<Id>();
	    	this.posAccIds = new set<Id>();
	    	for(Position_Account__c pa : posAccToBeProcessed){
	    		accountsToBeProcessed.add(pa.Account__c);
	    		posAccIds.add(pa.Id);
	    	}

	    	teamInstance = [SELECT Id, Scenario__c, Alignment_Period__c, Alignment_Type__c, Affiliation_Network__c, Scenario__r.Enable_Affiliation_Based_Alignment__c, EnableAccountSharing__c, IC_EffstartDate__c, IC_EffEndDate__c FROM Team_Instance__c WHERE Id =: teamInstanceId];
	    	if(teamInstance.Scenario__r.Enable_Affiliation_Based_Alignment__c && teamInstance.EnableAccountSharing__c && teamInstance.Affiliation_Network__c != null){
	    		affRule = getAffiliationBusinessRule(teamInstance.Scenario__c);
	    		if(affRule == null){
	    			throw new InsufficentPriviligesException('Affiliation rule not found');
	    		}
	    		query = 'Select logged__c, isExcluded__c, TempDestinationrgb__c, Team_Instance__c, SharedWith__c, Segment_1__c, Position__c, Position_Team_Instance__c, Name, Metric9__c, Metric8__c, Metric7__c, Metric6__c, Metric5__c, Metric4__c, Metric3__c, Metric2__c, Metric1__c, Metric10__c, Locked__c, Effective_Start_Date__c, Effective_End_Date__c, Comments__c, Affiliation_Based_Alignment__c, Account__c, Account_Target_Type__c, Account_Relationship_Type__c, Account_Alignment_Type__c From Position_Account__c ';
	    		query += 'WHERE Id IN : posAccIds AND Team_Instance__c =: teamInstanceId AND Assignment_Status__c != \''+SalesIQGlobalConstants.POSITION_ACCOUNT_INACTIVE+'\'';
	    	}else{
	    		query = 'SELECT Id, Team_Instance__c, Position__c, Account__c FROM Position_Account__c WHERE Name = null';
	    	}
    	}catch(Exception e){
    		system.debug('#### ERROR : '+e.getMessage());
    		query = 'SELECT Id, Team_Instance__c, Position__c, Account__c FROM Position_Account__c WHERE Name = null';
    		SalesIQLogger.logCatchedException(e,'Affiliation Rule Post Processing');
    	}
    	system.debug('#### query : '+query);
    }
    
    global Database.QueryLocator start(Database.BatchableContext BC){
		return Database.getQueryLocator(query);
	}
	
	global void execute(Database.BatchableContext BC,List<Position_Account__c> scope){
	    system.debug('#### scope : '+scope);
	    /*logic to fetch logic from external class.
	      If custom metadatatype is not there existing logic will execute.
	      Same will happen if external class is not mentioned therfore className is used if it is blank due to any 
	      reason existing code will execute.
	    */
	    list<Package_Extension__mdt> pkgExtList = SalesIQUtility.getPackageExtensionsByLabels(new set<string>{'Batch Extension'});
        system.debug('######## pkgExtList ' + pkgExtList);
        string className = '';
        if(pkgExtList != null && pkgExtList.size() > 0){
        	className = pkgExtList[0].ClassName__c;
        }
        if(className != '' && className != null){
        	IBatchExtension ext = SalesIQUtility.getBatchInterfaceInstance(className);
            if(ext != null){
            	ext.executeAffiliationBatch(scope,teamInstanceId,newlyAlignedAccounts);
            }
        
        }
        //logic from external class ends
        else{
		    try{
		    	map<Id,list<Position_Account__c>> selectedAccountAssignmentsMap = new map<Id,list<Position_Account__c>>();
	
			    for(Position_Account__c pa : scope){
			    	list<Position_Account__c> tempPosAcc = selectedAccountAssignmentsMap.get(pa.Account__c);
					if(tempPosAcc == null){
						tempPosAcc = new list<Position_Account__c>();
					}
					tempPosAcc.add(pa);
					selectedAccountAssignmentsMap.put(pa.Account__c,tempPosAcc);
			    }

				affRule = getAffiliationBusinessRule(teamInstance.Scenario__c);
			    
			    system.debug('#### Affiliation_Network__c : '+teamInstance.Affiliation_Network__c);
			    system.debug('#### ruleType : '+affRule.ruleType);
			    system.debug('#### geoPreference : '+affRule.geoPreference);
			    system.debug('#### childCriteria : '+affRule.childCriteria);
			    system.debug('#### parentCriteria : '+affRule.parentCriteria);
	
			    /*Find all affiliated accounts for the selected accounts*/
			    map<Id,set<Id>> accountAffiliationMap = fetchAffiliatedAccounts(accountsToBeProcessed, affRule, teamInstance.Affiliation_Network__c, true);
			    set<Id> affiliatedAccountIds = new set<Id>();
			    for(Id key : accountAffiliationMap.keyset()){
			    	//affiliatedAccountIds.addAll(accountAffiliationMap.get(key));
			    	for(Id accId : accountAffiliationMap.get(key)){
			    		//Exclude accounts that are unselected by user while movement (Only applicable for ZIP movement in Hybrid team)
			    		if(!excludedAccountIds.contains(accId)){
			    			affiliatedAccountIds.add(accId);
			    		}
			    	}
			    }
	
			    system.debug('#### accountAffiliations : '+affiliatedAccountIds);
	
			    /*Fetch all active/future active assignments for affiliated accounts.*/
			    map<Id,list<Position_Account__c>> affiliatedAccountAssignments = new map<Id,list<Position_Account__c>>();
			    list<Position_Account__c> affPositionAccounts = [SELECT logged__c, isExcluded__c, TempDestinationrgb__c, Team_Instance__c, SharedWith__c, Segment_1__c, Position__c, Position_Team_Instance__c, Name, Metric9__c, Metric8__c, Metric7__c, Metric6__c, Metric5__c, Metric4__c, Metric3__c, Metric2__c, Metric1__c, Metric10__c, Locked__c, Effective_Start_Date__c, Effective_End_Date__c, Comments__c, Affiliation_Based_Alignment__c, Account__c, Account_Target_Type__c, Account_Relationship_Type__c, Account_Alignment_Type__c 
								    							  FROM Position_Account__c WHERE Account__c IN : affiliatedAccountIds AND Team_Instance__c =: teamInstance.Id AND Assignment_Status__c !=: SalesIQGlobalConstants.POSITION_ACCOUNT_INACTIVE
																  Order By Assignment_Status__c];
			    for(Position_Account__c pa : affPositionAccounts){
					list<Position_Account__c> tempPosAcc = affiliatedAccountAssignments.get(pa.Account__c);
					if(tempPosAcc == null){
						tempPosAcc = new list<Position_Account__c>();
					}
					tempPosAcc.add(pa);
					affiliatedAccountAssignments.put(pa.Account__c,tempPosAcc);
			    }
			    system.debug('#### affiliatedAccountAssignments : '+affiliatedAccountAssignments);
	
			    list<Position_Account__c> assignmentsToBeCreated = new list<Position_Account__c>();
			    set<String> assignmentSetForDuplicateCheck = new set<String>();
			    for(Id selectedAccount : accountAffiliationMap.keyset()){
			    	system.debug('#### selectedAccount : '+selectedAccount);
			    	list<Position_Account__c> selectedAccountAssignments = selectedAccountAssignmentsMap.get(selectedAccount);
			    	system.debug('#### selectedAccountAssignments : '+selectedAccountAssignments);
			    	if(selectedAccountAssignments != null){
    			    	for(Position_Account__c selectedAccAss : selectedAccountAssignments){
    			    		system.debug('#### selectedAccAss : '+selectedAccAss.Id);
    						for(Id affAccId : accountAffiliationMap.get(selectedAccAss.Account__c)){
    							//Exclude accounts that are unselected by user while movement (Only applicable for ZIP movement in Hybrid team)
    							if(!excludedAccountIds.contains(affAccId)){
    								system.debug('#### affAccId : '+affAccId);
    				    			set<Id> positionIdSet = new set<Id>();
    								Position_Account__c assignmentToClone;
    								if(affiliatedAccountAssignments.containsKey(affAccId)){
    									for(Position_Account__c affAccAss : affiliatedAccountAssignments.get(affAccId)){
    										system.debug('#### affAccAss : '+affAccAss.Id);
    										positionIdSet.add(affAccAss.Position__c);
    										assignmentToClone = affAccAss;
    									}
    								}else{
    									/*If there is no active assignments for affiliated account, clone new assignment from selected account and reset the metric values*/
    									assignmentToClone = selectedAccAss;
    									assignmentToClone.Account__c = affAccId;
    									assignmentToClone.Metric1__c = 0;
    									assignmentToClone.Metric2__c = 0;
    									assignmentToClone.Metric3__c = 0;
    									assignmentToClone.Metric4__c = 0;
    									assignmentToClone.Metric5__c = 0;
    									assignmentToClone.Metric6__c = 0;
    									assignmentToClone.Metric7__c = 0;
    									assignmentToClone.Metric8__c = 0;
    									assignmentToClone.Metric9__c = 0;
    									assignmentToClone.Metric10__c = 0;
    								}
    								
    								system.debug('assignmentSetForDuplicateCheck.contains('+selectedAccAss.Position__c+' @ '+affAccId+') : '+assignmentSetForDuplicateCheck.contains(selectedAccAss.Position__c+'@'+affAccId));
    								if(!positionIdSet.contains(selectedAccAss.Position__c) && !assignmentSetForDuplicateCheck.contains(selectedAccAss.Position__c+'@'+affAccId)){
    									Position_Account__c newAssignment = assignmentToClone.clone(false,true,false,false);
    									newAssignment.Position__c = selectedAccAss.Position__c;
    									newAssignment.Affiliation_Based_Alignment__c = true;
    									if(teamInstance.Alignment_Period__c == SalesIQGlobalConstants.FUTURE_TEAM_CYCLE_TYPE){
    										newAssignment.Effective_Start_Date__c = teamInstance.IC_EffstartDate__c;
    									}else{
    										newAssignment.Effective_Start_Date__c = system.today();
    									}
    									newAssignment.SharedWith__c = null;
    									newAssignment.IsShared__c = false;
    									newAssignment.Effective_End_Date__c = teamInstance.IC_EffEndDate__c;
    									assignmentsToBeCreated.add(newAssignment);
    									newlyAlignedAccounts.add(newAssignment.Account__c);
    									assignmentSetForDuplicateCheck.add(newAssignment.Position__c+'@'+newAssignment.Account__c);
    								}
    				    		}
    						}
    			    	}
    			    }
			    }
	
			    /*Check align to geo assignments if Geo Preference is Align in Geo. This will remove not aligned assignments from assignmentsToBeCreated.*/
			    if(affRule.geoPreference == 'Align in Geo'){
			    	assignmentsToBeCreated = checkAccountAlignmentType(assignmentsToBeCreated);
			    }
	
			    affiliatedAccountIds = new set<Id>();
			    for(Position_Account__c pa : assignmentsToBeCreated){
			    	/**
			    	* Modified : Raghvendra | 27 Sep 2018 | SIQ-2715
			    	* All the assignments created through affiliation will be  marked as Implicit
			    	**/
			    	//pa.Account_Alignment_Type__c = SalesIQGlobalConstants.CR_ACCOUNT_EXPLICIT_STATUS;
			    	pa.Account_Alignment_Type__c = SalesIQGlobalConstants.CR_ACCOUNT_IMPLICIT_STATUS;
			    	affiliatedAccountIds.add(pa.Account__c);
			    }
	
			    system.debug('#### assignmentsToBeCreated : '+assignmentsToBeCreated);
			    if(assignmentsToBeCreated.size() > 0){
			    	/*Process pending CRs for affiliated accounts.*/
				    processPendingCR(assignmentsToBeCreated, affiliatedAccountIds, teamInstance.Id, BC.getJobId());
	
				    /*Insert assignments created due to affliation rules*/
				    insert assignmentsToBeCreated;
				    
				    /*Update CIM Summary for new assignments*/
					updateCIMSummary(assignmentsToBeCreated, 'Create');
			    }
	
			    /*Find affiliation assignments for affiliated account in source*/
			    set<Id> srcPosIds = new set<Id>();
			    map<Id,list<Position_Account__c>> affiliationAssignmentsInSrc = new map<Id,list<Position_Account__c>>();
			    for(Id parentId : affiliatedAccountAssignments.keyset()){
			    	for(Position_Account__c pa : affiliatedAccountAssignments.get(parentId)){
			    		if(pa.Affiliation_Based_Alignment__c){
			    			srcPosIds.add(pa.Position__c);
			    			list<Position_Account__c> temp = affiliationAssignmentsInSrc.get(pa.Account__c);
			    			if(temp == null){
			    				temp = new list<Position_Account__c>();
			    			}
			    			temp.add(pa);
			    			affiliationAssignmentsInSrc.put(pa.Account__c,temp);
			    		}
			    	}
			    }
	
			    AffiliationRule reverseAffRule = affRule;
			    reverseAffRule.ruleType = affRule.ruleType == SalesIQGlobalConstants.AFF_RULE_BOTTOM_UP ? SalesIQGlobalConstants.AFF_RULE_TOP_DOWN : SalesIQGlobalConstants.AFF_RULE_BOTTOM_UP;
			    /*Find child/parent of affiliated accounts*/
			    map<Id,set<Id>> affAndRelatedAccountMap = fetchAffiliatedAccounts(affiliationAssignmentsInSrc.keyset(), reverseAffRule, teamInstance.Affiliation_Network__c, false);
			    set<Id> relatedAccountIds = new set<Id>();
			    for(Id key : affAndRelatedAccountMap.keyset()){
			    	relatedAccountIds.addAll(affAndRelatedAccountMap.get(key));
			    }
	
			    system.debug('#### relatedAccountIds : '+relatedAccountIds);
			    map<Id,list<Position_Account__c>> relAccSrcAssignmentMap = new map<Id,list<Position_Account__c>>();
			    for(Position_Account__c pa : [SELECT Id, Team_Instance__c, Position__c, Account__c FROM Position_Account__c 
		    							  	  WHERE Account__c IN : relatedAccountIds AND Team_Instance__c =: teamInstance.Id
		    							  	  AND Position__c IN : srcPosIds AND Assignment_Status__c !=: SalesIQGlobalConstants.POSITION_ACCOUNT_INACTIVE
										  	  Order By Assignment_Status__c]){
			    	list<Position_Account__c> temp = relAccSrcAssignmentMap.get(pa.Account__c);
			    	if(temp == null){
			    		temp = new list<Position_Account__c>();
			    	}
			    	temp.add(pa);
			    	relAccSrcAssignmentMap.put(pa.Account__c,temp);
			    }
	
			    system.debug('#### relAccSrcAssignmentMap : '+relAccSrcAssignmentMap);
	
			    map<Id,set<Id>> affToRelAssignmentMap = new map<Id,set<Id>>();
			    for(Id key : affAndRelatedAccountMap.keyset()){
			    	for(Id child : affAndRelatedAccountMap.get(key)){
			    		if(!relAccSrcAssignmentMap.containsKey(child)){
				    		continue;
				    	}
			    		for(Position_Account__c pa : relAccSrcAssignmentMap.get(child)){
			    			set<Id> tempSet = affToRelAssignmentMap.get(key);
			    			if(tempSet == null){
			    				tempSet = new set<Id>();
			    			}
			    			tempSet.add(pa.Position__c);
			    			affToRelAssignmentMap.put(key,tempSet);
			    		}
			    	}
			    }
				system.debug('#### affToRelAssignmentMap : '+affToRelAssignmentMap);
				system.debug('#### affiliationAssignmentsInSrc : '+affiliationAssignmentsInSrc);
			    
			    list<Position_Account__c> assignmentsToBeEndDated = new list<Position_Account__c>();
			    for(Id parentId : affiliationAssignmentsInSrc.keyset()){
			    	set<Id> positionSet = affToRelAssignmentMap.get(parentId);
			    	system.debug('#### '+parentId+' : '+positionSet);
			    	for(Position_Account__c pa : affiliationAssignmentsInSrc.get(parentId)){
			    		if(pa.Affiliation_Based_Alignment__c && (positionSet == null || !positionSet.contains(pa.Position__c))){
			    			pa.Effective_End_Date__c = system.today()-1;
			    			assignmentsToBeEndDated.add(pa);
			    		}
			    	}
			    }
	
			    system.debug('#### assignmentsToBeEndDated : '+assignmentsToBeEndDated);
			    if(assignmentsToBeEndDated.size() > 0){
			    	/*Update CIM Summary for deleted assignments*/
					updateCIMSummary(assignmentsToBeEndDated,'Delete');
			    	if(teamInstance.Alignment_Period__c == SalesIQGlobalConstants.FUTURE_TEAM_CYCLE_TYPE){
						delete assignmentsToBeEndDated;
					}else{
						update assignmentsToBeEndDated;
					}
			    }
	
		    }catch(Exception e){
				system.debug('#### ERROR : '+e.getMessage());
				SalesIQLogger.logCatchedException(e,'Affiliation Rule Post Processing');
		    }
	    }
	}
	
	global void finish(Database.BatchableContext BC){
		system.debug('#### newlyAlignedAccounts : '+newlyAlignedAccounts);
		if(newlyAlignedAccounts.size() > 0){
			/*Invoke batch to update shared assignments*/
			database.executeBatch(new UpdatePositionAccountSharedBatch(teamInstanceId,newlyAlignedAccounts));
		}
	}

	/*Method to find Affiliation business rule defined for selected team instance's scenario*/
	private AffiliationRule getAffiliationBusinessRule(Id scenarioId){
		list<Business_Rules__c> affiliationRule = [SELECT Id, Scenario__c, Geographic_Preference__c, Rule_Type__c, Level__c, 
													(SELECT Id, Affiliation_Hierarchy__c, where_expression_source__c FROM BRJoinRules__r order by Affiliation_Hierarchy__c) 
													FROM Business_Rules__c WHERE Scenario__c =: scenarioId AND Business_Rule_Type_Master__r.Name = 'Affiliation' 
													AND Rule_Type__c != 'No Affiliation' limit 1];

		if(affiliationRule.size() == 1){
			String childCriteria = '';
			String parentCriteria = '';

			Map<String, Schema.SObjectField> accFields = Schema.SObjectType.Account.fields.getMap();

			for(BR_JoinRule__c ruleCriteria : affiliationRule[0].BRJoinRules__r){
			    if(ruleCriteria.Affiliation_Hierarchy__c == null || ruleCriteria.where_expression_source__c == null){
			        throw new InsufficentPriviligesException('Affiliation rule criteria is not configured correctly.');
			    }
			    
				if(ruleCriteria.Affiliation_Hierarchy__c == 'child'){
					for(String fieldName : accFields.keyset()){
						if(ruleCriteria.where_expression_source__c.toLowerCase().contains(' '+fieldName+' ')){
							system.debug('#### child fieldName : '+fieldName);
							ruleCriteria.where_expression_source__c = ruleCriteria.where_expression_source__c.toLowerCase().replace(' '+fieldName+' ',' Account__r.'+fieldName+' ');
						}
					}
					childCriteria += ruleCriteria.where_expression_source__c + ' AND ';
				}else{
					for(String fieldName : accFields.keyset()){
						if(ruleCriteria.where_expression_source__c.toLowerCase().contains(' '+fieldName+' ')){
							system.debug('#### parent fieldName : '+fieldName);
							ruleCriteria.where_expression_source__c = ruleCriteria.where_expression_source__c.toLowerCase().replace(' '+fieldName+' ',' Parent_Account__r.'+fieldName+' ');
						}
					}
					parentCriteria += ruleCriteria.where_expression_source__c + ' AND ';
				}
			}

			childCriteria = childCriteria.removeEnd(' AND ');
			parentCriteria = parentCriteria.removeEnd(' AND ');

			return new AffiliationRule(affiliationRule[0].Geographic_Preference__c, affiliationRule[0].Rule_Type__c, childCriteria, parentCriteria, affiliationRule[0].Level__c, affiliationHierarchyThreshold);
		}else{
			return null;
		}
	}

	/*Method to find  affiliated (child/parent) accounts for selected accounts based on the business rule type.*/
	private map<Id,set<Id>> fetchAffiliatedAccounts(set<Id> accountIds, AffiliationRule affRule, string affiliationNetwork, boolean isNLevel){
		system.debug('#### accountIds : '+accountIds);
		system.debug('#### hierarchyLevel : '+affRule.hierarchyLevel);
		system.debug('#### affiliationHierarchyThreshold : '+affiliationHierarchyThreshold);

		set<Id> currentLevelAccount = new set<Id>(accountIds);
		map<Id,set<Id>> affiliationMap = new map<Id,set<Id>>();

		map<Id,Id> affToSelAccountMap = new map<Id,Id>();
		if(isNLevel){
			for(integer i = 1 ; i <= affRule.hierarchyLevel && i <= affiliationHierarchyThreshold ; i++){
				system.debug('#### Finding '+i+ ' level affiliation accounts');
				system.debug('#### '+(i-1)+' level accounts : '+currentLevelAccount);
				string affiliationSOQL = 'SELECT Id, Account__c, Parent_Account__c FROM Account_Affiliation__c WHERE Affiliation_Network__c =: affiliationNetwork ';
				
				system.debug('#### childCriteria : '+affRule.childCriteria);
				system.debug('#### parentCriteria : '+affRule.parentCriteria);

				if(affRule.ruleType == SalesIQGlobalConstants.AFF_RULE_BOTTOM_UP && affRule.parentCriteria != ''){
					affiliationSOQL += 'AND Account__c IN : currentLevelAccount AND Parent_Account__c != null ';
					affiliationSOQL += 'AND '+affRule.parentCriteria + ' ';
					if(i == 1){
						affiliationSOQL += 'AND '+affRule.childCriteria + ' ';
					}
				}else if(affRule.ruleType == SalesIQGlobalConstants.AFF_RULE_TOP_DOWN && affRule.childCriteria != ''){
					affiliationSOQL += 'AND Parent_Account__c IN : currentLevelAccount ';
					if(i == 1){
						affiliationSOQL += 'AND '+affRule.parentCriteria + ' ';
					}
					affiliationSOQL += 'AND '+affRule.childCriteria+' ';
				}
				affiliationSOQL += 'AND Is_Primary__c = TRUE AND Active__c = TRUE';

				system.debug('#### affiliationSOQL : '+affiliationSOQL);
				set<Id> currentLevelAccountIds = new set<Id>();
				for(Account_Affiliation__c af : database.query(affiliationSOQL)){
					if(affRule.ruleType == SalesIQGlobalConstants.AFF_RULE_BOTTOM_UP){
						currentLevelAccountIds.add(af.Parent_Account__c);
						if(affToSelAccountMap.containsKey(af.Account__c)){
							set<Id> tempSet = affiliationMap.get(affToSelAccountMap.get(af.Account__c));
							if(tempSet == null){
								tempSet = new set<Id>();
							}
							tempSet.add(af.Parent_Account__c);
							affiliationMap.put(affToSelAccountMap.get(af.Account__c),tempSet);
							affToSelAccountMap.put(af.Parent_Account__c,affToSelAccountMap.get(af.Account__c));
						}else{
							set<Id> tempSet = affiliationMap.get(af.Account__c);
							if(tempSet == null){
								tempSet = new set<Id>();
							}
							tempSet.add(af.Parent_Account__c);
							affiliationMap.put(af.Account__c,tempSet);
							affToSelAccountMap.put(af.Parent_Account__c,af.Account__c);
						}
					}else{
						currentLevelAccountIds.add(af.Account__c);
						if(affToSelAccountMap.containsKey(af.Parent_Account__c)){
							set<Id> tempSet = affiliationMap.get(affToSelAccountMap.get(af.Parent_Account__c));
							if(tempSet == null){
								tempSet = new set<Id>();
							}
							tempSet.add(af.Account__c);
							affiliationMap.put(affToSelAccountMap.get(af.Parent_Account__c),tempSet);
							affToSelAccountMap.put(af.Account__c,affToSelAccountMap.get(af.Parent_Account__c));
						}else{
							set<Id> tempSet = affiliationMap.get(af.Parent_Account__c);
							if(tempSet == null){
								tempSet = new set<Id>();
							}
							tempSet.add(af.Account__c);
							affiliationMap.put(af.Parent_Account__c,tempSet);
							affToSelAccountMap.put(af.Account__c,af.Parent_Account__c);
						}
					}
				}
				system.debug('#### Reinit currentLevelAccount with level '+i+' accounts');
				if(currentLevelAccountIds.size() == 0){
					break;
				}
				currentLevelAccount = new set<Id>(currentLevelAccountIds);
			}
		}else{
			string affiliationSOQL = 'SELECT Id, Account__c, Parent_Account__c FROM Account_Affiliation__c WHERE Affiliation_Network__c =: affiliationNetwork ';
			if(affRule.ruleType == SalesIQGlobalConstants.AFF_RULE_BOTTOM_UP){
				affiliationSOQL += 'AND Account__c IN : accountIds AND Parent_Account__c != null ';
			}else{
				affiliationSOQL += 'AND Parent_Account__c IN : accountIds ';
			}
			affiliationSOQL += 'AND Is_Primary__c = TRUE AND Active__c = TRUE';

			system.debug('#### affiliationSOQL : '+affiliationSOQL);

			for(Account_Affiliation__c af : database.query(affiliationSOQL)){
				if(affRule.ruleType == SalesIQGlobalConstants.AFF_RULE_BOTTOM_UP){
					set<Id> tempSet = affiliationMap.get(af.Account__c);
					if(tempSet == null){
						tempSet = new set<Id>();
					}
					tempSet.add(af.Parent_Account__c);
					affiliationMap.put(af.Account__c,tempSet);
				}else{
					set<Id> tempSet = affiliationMap.get(af.Parent_Account__c);
					if(tempSet == null){
						tempSet = new set<Id>();
					}
					tempSet.add(af.Account__c);
					affiliationMap.put(af.Parent_Account__c,tempSet);
				}
			}
		}

		system.debug('#### affiliationMap : '+affiliationMap);
		return affiliationMap;
	}

	/*Method to process pending CRs on affiliated accounts*/
	private void processPendingCR(list<Position_Account__c> lstPositionAccount, set<id> accountIds, Id teamInstanceId, string jobId){
		set<Id> crIds = new set<Id>();
		map<Id,list<CR_Account__c>> mapAccountCRAccount = new map<Id,list<CR_Account__c>>();
		/*Getting CR_Account of selected account. */
		system.debug('#### accountIds : '+accountIds);
		system.debug('#### teamInstanceId : '+teamInstanceId);
		list<CR_Account__c> crAccounts = [SELECT Id, Account__c, Change_Request__c, Change_Request__r.Source_Position__c, Change_Request__r.Destination_Position__c, Source_Position__c, Destination_Position__c FROM CR_Account__c WHERE Account__c IN : accountIds AND 
										  Change_Request__r.Status__c =: SalesIQGlobalConstants.REQUEST_STATUS_PENDING AND Change_Request__r.Team_Instance_Id__c =: teamInstanceId];
		for(CR_Account__c crAcc : crAccounts){
			crIds.add(crAcc.Change_Request__c);
			list<CR_Account__c> tempCRAccount = mapAccountCRAccount.get(crAcc.Account__c);
			if(tempCRAccount == null){
				tempCRAccount = new list<CR_Account__c>();
			}
			tempCRAccount.add(crAcc);
			mapAccountCRAccount.put(crAcc.Account__c, tempCRAccount);
		}

		if(crIds.size() > 0){
			/*Find out CRs if there is no accounts associated other than affiliated accounts and mark it rejected.*/
			list<Id> CRToBeRejected = new list<Id>();
			for(Change_Request__c cr : [SELECT Id, (SELECT Id FROM CR_Accounts__r WHERE Account__c NOT IN : accountIds) FROM Change_Request__c WHERE Id IN : crIds]){
				if(cr.CR_Accounts__r.size() == 0){
					crToBeRejected.add(cr.Id);
					crIds.remove(cr.Id);
				}
			}
			system.debug('#### CRs to be rejected : '+crToBeRejected);
			if(crToBeRejected.size() > 0){
				/*Submit CRs for rejection*/
				SalesIQUtility.submitForRejection(crToBeRejected,Label.Rejection_Comment_Affiliation);
			}
		}

		/*Process other CRs to recalculate the CIM impact and delete the CR Accounts*/
		system.debug('#### CRs to recalculate : '+crIds);
		set<string> sourcePositions = new set<string>();
		set<string> destinationPositions = new set<string>();
		if(crIds.size() > 0){
			/*Getting the CIM request Impact for all CR which are part of CR Account*/
			list<CIM_Change_Request_Impact__c> lstCIMReqImpact = [SELECT Id, Impact__c, Change_Request__c, CIM_Config__r.Attribute_API_Name__c, Change_Request__r.Source_Position__c, Change_Request__r.Destination_Position__c 
																  FROM CIM_Change_Request_Impact__c WHERE Change_Request__c IN : crIds];

			map<id, list<CIM_Change_Request_Impact__c>> mapCRtoCIMReqImpact = new map<id, list<CIM_Change_Request_Impact__c>>();
			for(CIM_Change_Request_Impact__c crImpact : lstCIMReqImpact){
				sourcePositions.add(crImpact.Change_Request__r.Source_Position__c);
				destinationPositions.add(crImpact.Change_Request__r.Destination_Position__c);

				list<CIM_Change_Request_Impact__c> tempCRImpact = mapCRtoCIMReqImpact.get(crImpact.Change_Request__c);
				if(tempCRImpact == null){
					tempCRImpact = new list<CIM_Change_Request_Impact__c>();
				}
				tempCRImpact.add(crImpact);
				mapCRtoCIMReqImpact.put(crImpact.Change_Request__c,tempCRImpact);
			}

			map<Id,list<CIM_Position_Metric_Summary__c>> positionCIMSummaryMap = new map<Id, list<CIM_Position_Metric_Summary__c>>();
			for(CIM_Position_Metric_Summary__c cim : [SELECT Id, Position_Team_Instance__r.Position_ID__c, CIM_Config__c, CIM_Config__r.Attribute_API_Name__c, Proposed__c FROM CIM_Position_Metric_Summary__c 
													  WHERE (Position_Team_Instance__r.Position_ID__c IN : sourcePositions OR 
													  Position_Team_Instance__r.Position_ID__c IN : destinationPositions) AND 
													  CIM_Config__r.Change_Request_Type__r.CR_Type_Name__c =: SalesIQGlobalConstants.MOVEMENT_TYPE_ACCOUNT]){
				list<CIM_Position_Metric_Summary__c> tempCIMList = positionCIMSummaryMap.get(cim.Position_Team_Instance__r.Position_ID__c);
				if(tempCIMList == null){
					tempCIMList = new list<CIM_Position_Metric_Summary__c>();
				}
				tempCIMList.add(cim);
				positionCIMSummaryMap.put(cim.Position_Team_Instance__r.Position_ID__c,tempCIMList);
			}
			system.debug('#### positionCIMSummaryMap : '+positionCIMSummaryMap);
			
			list<CIM_Change_Request_Impact__c> crImpactToUpdate = new list<CIM_Change_Request_Impact__c>();
			set<CIM_Position_Metric_Summary__c> cimSummaryToUpdate = new set<CIM_Position_Metric_Summary__c>();
			list<CR_Account__c> crAccToDelete = new list<CR_Account__c>();

			for(position_Account__c posAcc : lstPositionAccount){
				system.debug('#### posAcc : '+posAcc.Id);
				/*Continue of there is no pending CR Account for this account*/
				if(!mapAccountCRAccount.containsKey(posAcc.Account__c)){
					continue;
				}
				
				for(CR_Account__c crAcc : mapAccountCRAccount.get(posAcc.Account__c)){
					/*Update the CR impact only for Hybrid and Account based teams*/
					if(teamInstance.Alignment_Type__c != SalesIQGlobalConstants.ALIGNMENT_TYPE_ZIP){
						/*Continue if this is the only account associated with the CR*/
						if(!mapCRtoCIMReqImpact.containsKey(crAcc.Change_Request__c)){
							continue;
						}
						for(CIM_Change_Request_Impact__c crImpact : mapCRtoCIMReqImpact.get(crAcc.Change_Request__c)){
							system.debug('#### KPI : '+crImpact.CIM_Config__r.Attribute_API_Name__c);
							system.debug('#### KPI Value : '+crImpact.Impact__c);
							decimal accMetric = double.valueOf(posAcc.get(crImpact.CIM_Config__r.Attribute_API_Name__c));
							system.debug('#### ACC KPI : '+accMetric);
							decimal newval = 0;
							if(crImpact.Impact__c.contains('-')){
	                            newval = double.valueOf(crImpact.Impact__c) + accMetric;
	                            system.debug('Updated negative '+crImpact.CIM_Config__r.Attribute_API_Name__c+' : '+newval);
	                            crImpact.Impact__c = string.valueOf(newval);
	                        }else{
	                            newval = double.valueOf(crImpact.Impact__c) - accMetric;
	                            system.debug('Updated positive '+crImpact.CIM_Config__r.Attribute_API_Name__c+' : '+newval);
	                            crImpact.Impact__c = '+' + string.valueOf(newval);
	                        }
	                        crImpactToUpdate.add(crImpact);
						}
					}
					crAccToDelete.add(crAcc);
				
					/*Update Proposed value CIM Position Metric Summary only for Hybrid and Account based teams*/
					if(teamInstance.Alignment_Type__c != SalesIQGlobalConstants.ALIGNMENT_TYPE_ZIP){
						for(CIM_Position_Metric_Summary__c cim : positionCIMSummaryMap.get(crAcc.Change_Request__r.Source_Position__c)){
							system.debug('#### KPI NAME : '+cim.CIM_Config__r.Attribute_API_Name__c);
							system.debug('#### SRC KPI VALUE : '+cim.Proposed__c);
							system.debug('#### ACC KPI VALUE : '+posAcc.get(cim.CIM_Config__r.Attribute_API_Name__c));
							decimal accMetric = double.valueOf(posAcc.get(cim.CIM_Config__r.Attribute_API_Name__c));
							decimal updatedKPI  = double.valueOf(cim.Proposed__c) + accMetric;
							cim.Proposed__c = string.valueOf(updatedKPI);
							system.debug('#### UPDATED KPI VALUE : '+cim.Proposed__c);
							cimSummaryToUpdate.add(cim);
						}

						for(CIM_Position_Metric_Summary__c cim : positionCIMSummaryMap.get(crAcc.Change_Request__r.Destination_Position__c)){
							system.debug('#### KPI NAME : '+cim.CIM_Config__r.Attribute_API_Name__c);
							system.debug('#### DEST KPI VALUE : '+cim.Proposed__c);
							system.debug('#### ACC KPI VALUE : '+posAcc.get(cim.CIM_Config__r.Attribute_API_Name__c));
							decimal accMetric = double.valueOf(posAcc.get(cim.CIM_Config__r.Attribute_API_Name__c));
							decimal updatedKPI  = double.valueOf(cim.Proposed__c) - accMetric;
							cim.Proposed__c = string.valueOf(updatedKPI);
							system.debug('#### UPDATED KPI VALUE : '+cim.Proposed__c);
							cimSummaryToUpdate.add(cim);
						}
					}
				}
			}

			if(crImpactToUpdate.size() > 0){
				update crImpactToUpdate;
			}

			if(crAccToDelete.size() > 0){
				createExclulsionLogger(crAccToDelete,jobId);
				delete crAccToDelete;
			}

			if(cimSummaryToUpdate.size() > 0){
				update new list<CIM_Position_Metric_Summary__c>(cimSummaryToUpdate);
			}
		}
	}
	
    /*Method to create logs for deleted CR accounts*/
	@TestVisible
	private void createExclulsionLogger(list<CR_Account__c> crAccToDelete, string jobId){
		list<Exclusion_Logger__c> lstAccountLogger = new list<Exclusion_Logger__c>();
		for(CR_Account__c crAcc : crAccToDelete){
			Exclusion_Logger__c objCRAccountlogger = new Exclusion_Logger__c();
            objCRAccountlogger.Account__c = crAcc.Account__c;                                
            objCRAccountlogger.Change_Request__c = crAcc.Change_Request__c;
            objCRAccountlogger.Source_Position__c = crAcc.Source_Position__c;
            objCRAccountlogger.Destination_Position__c = crAcc.Destination_Position__c;
            objCRAccountlogger.Batch_Job_Id__c = jobId;
            objCRAccountlogger.Batch_Type__c='Account Affiliation';
            objCRAccountlogger.Source_object__c = 'CR_Account__c';
            lstAccountLogger.add(objCRAccountlogger);
		}
		if(lstAccountLogger.size() > 0){
			insert lstAccountLogger;
		}
	}

	/*Method to check if Accont is Aligned to geography*/
	@TestVisible
	private list<Position_Account__c> checkAccountAlignmentType(list<Position_Account__c> lstPositionAccount){
		system.debug('#### checkAccountAlignmentType called');
		list<Position_Account__c> implicitAssignments = new list<Position_Account__c>();
		set<Id> positionIds = new set<Id>();
		set<Id> accountIds = new set<Id>();
		for(Position_Account__c pa : lstPositionAccount){
			positionIds.add(pa.Position__c);
			accountIds.add(pa.Account__c);
		}

		map<Id,Account> accountMap = new map<Id,Account>([SELECT Id, BillingPostalCode FROM Account WHERE Id in : accountIds]);
		map<Id,set<string>> positionGeographyMap = new map<Id,set<string>>();

		String assignmentStatus='';
		if(teamInstance.Alignment_Period__c == SalesIQGlobalConstants.CURRENT_TEAM_CYCLE_TYPE){
            assignmentStatus = SalesIQGlobalConstants.POSITION_GEOGRAPHY_ACTIVE;
        }else{
            assignmentStatus = SalesIQGlobalConstants.POSITION_GEOGRAPHY_FUTURE_ACTIVE;
        }

		for(Position_Geography__c pg : [SELECT Id, Position__c, Geography__r.Name FROM Position_Geography__c 
										WHERE Position__c in : positionIds AND Assignment_Status__c =: assignmentStatus AND 
										Team_Instance__c =: teamInstance.Id]){
			set<string> tempZIPs = positionGeographyMap.get(pg.Position__c);
			if(tempZIPs == null){
				tempZIPs = new set<string>();
			}
			tempZIPs.add(pg.Geography__r.Name);
			positionGeographyMap.put(pg.Position__c, tempZIPs);
		}

		for(Position_Account__c pa : lstPositionAccount){
			if(positionGeographyMap.containsKey(pa.Position__c) && accountMap.containsKey(pa.Account__c)){
				system.debug('#### Position ZIP : '+positionGeographyMap.get(pa.Position__c));
				system.debug('#### Account PostalCode : '+accountMap.get(pa.Account__c).BillingPostalCode);
				if(positionGeographyMap.get(pa.Position__c).contains(accountMap.get(pa.Account__c).BillingPostalCode)){
					pa.Account_Alignment_Type__c = SalesIQGlobalConstants.CR_ACCOUNT_IMPLICIT_STATUS;
				}else{
					pa.Account_Alignment_Type__c = SalesIQGlobalConstants.CR_ACCOUNT_EXPLICIT_STATUS;
				}
			}else{
				pa.Account_Alignment_Type__c = SalesIQGlobalConstants.CR_ACCOUNT_IMPLICIT_STATUS;
			}
			if(pa.Account_Alignment_Type__c == SalesIQGlobalConstants.CR_ACCOUNT_IMPLICIT_STATUS){
				implicitAssignments.add(pa);
			}
		}

		system.debug('#### Assignments aligned to geo : '+implicitAssignments);
		return implicitAssignments;
	}

	/*Method  to update CIM Summary for assignments created/deleted due to affiliation*/
	private void updateCIMSummary(list<Position_Account__c> posAccList, string operation){
		set<String> positionIds = new set<String>();
		for(Position_Account__c pa : posAccList){
			positionIds.add(pa.Position__c);
		}
		map<string, list<CIM_Position_Metric_Summary__c>> mapPositionAndMetricSummary = ProcessAccountExclusionBatch.getCIMPositionMetricSummary(positionIds);
		map<Id,CIM_Position_Metric_Summary__c> cimSummaryToUpdate = new map<Id,CIM_Position_Metric_Summary__c>();

		if(mapPositionAndMetricSummary != null && mapPositionAndMetricSummary.size() > 0){
			for(Position_Account__c posacc : posAccList){
				if(posacc.Team_Instance__r.Alignment_Type__c != SalesIQGlobalConstants.ALIGNMENT_TYPE_ZIP){
					for(CIM_Position_Metric_Summary__c summary : mapPositionAndMetricSummary.get(posacc.Position__c)){
						Decimal accMetricVal = double.valueOf(posacc.get(summary.CIM_Config__r.Attribute_API_Name__c));
						Decimal summaryProposedVal = double.valueOf(summary.Proposed__c);
                        Decimal summaryApprovedVal = double.valueOf(summary.Approved__c);
                        if(operation == 'Create'){
                        	summaryProposedVal = summaryProposedVal + accMetricVal;
                        	summaryApprovedVal = summaryApprovedVal + accMetricVal;
                        }else{
                        	summaryProposedVal = summaryProposedVal - accMetricVal;
                        	summaryApprovedVal = summaryApprovedVal - accMetricVal;
                        }

                        if(summaryProposedVal > 0){
                        	summary.Proposed__c = string.valueOf(summaryProposedVal);
                        }else{
                        	summary.Proposed__c = '0';
                        }

                        if(summaryApprovedVal > 0){
                        	summary.Approved__c = string.valueOf(summaryApprovedVal);
                        }else{
                        	summary.Approved__c = '0';
                        }

                        cimSummaryToUpdate.put(summary.Id,summary);
					}
				}
			}
		}
		if(cimSummaryToUpdate.size() > 0){
            update cimSummaryToUpdate.values();
        } 
	}

	public class AffiliationRule{
		Integer hierarchyLevel;
		string geoPreference;
		string ruleType;
		string childCriteria;
		string parentCriteria;
		public AffiliationRule(string geoPreference, string ruleType, string childCriteria,string parentCriteria, string affLevel, Integer affLevelThreshold){
			if(affLevel == 'All'){
				this.hierarchyLevel = affLevelThreshold;
			}else{
				this.hierarchyLevel = Integer.valueOf(affLevel);
			}
			this.geoPreference = geoPreference;
			this.ruleType = ruleType;
			this.childCriteria = childCriteria;
			this.parentCriteria = parentCriteria;
		}
	}
}